import { world, system, WeatherType } from "@minecraft/server"
import * as f from "@minecraft/server-ui"

system.beforeEvents.watchdogTerminate.subscribe(eventData => {
    console.error("watchdog = " + eventData.terminateReason +
        " trying to cancel crash")
    eventData.cancel = true
})

world.afterEvents.itemUseOn.subscribe((data) => {
    const block = data.block
    const item = data.itemStack
    const player = data.source
    
    if (block.typeId == "minecraft:bed") {
        const time1 = world.getTimeOfDay()
        let currentTime1 = "Sabah"
        if (time1 >= 13000 || time1 < 10) {
            currentTime1 = 'Gece'
        }
        if (currentTime1 != "Gece") {
            showForm(player)
        } else {
            player.runCommandAsync(`camera @s fade time 0.5 3 1`)
            player.runCommandAsync(`title @a actionbar ${player.name} uyuyor`)
            system.runTimeout(() => {
                world.setTimeOfDay(0);
                world.getDimension('overworld').setWeather(WeatherType.Clear)
                player.runCommandAsync(`title @s actionbar Günaydın`)
            }, 30)
        }
    }
})

function showForm(player) {
    const formdata = new f.ActionFormData()
    const time = world.getTimeOfDay()
    let currentTime = "Sabah"

    if (time >= 5000 && time < 9000) {
        currentTime = 'Öylen'
    }
    if (time >= 9000 && time < 13000) {
        currentTime = 'Akşam'
    }

    if (time >= 13000 || time < 10) {
        currentTime = 'Gece'
    }

    let formButtons = [];


    formdata.title('Uyuma menüsü').body(`Şimdi ${currentTime} saati`)

    if (currentTime != 'Sabah') {
        formdata.button('Sabaha kadar uyu')
        formButtons.push('Sabah')
    }
    if (currentTime != 'Öylen') {
        formdata.button('Öylene kadar uyu')
        formButtons.push('Öylen')
    }
    if (currentTime != 'Akşam') {
        formdata.button('Akşama kadar uyu')
        formButtons.push('Akşam')
    }
    if (currentTime != 'Gece') {
        formdata.button('Geceye kadar uyu')
        formButtons.push('Gece')
    }

    formdata.show(player).then((response) => {
        if (response.canceled) {
            return;
        }
        world.getDimension('overworld').setWeather(WeatherType.Clear)
        player.runCommandAsync(`camera @s fade time 1 1 1`)
        player.runCommandAsync(`title @a actionbar ${player.name} uyuyor`)
        system.runTimeout(() => {
            switch (formButtons[response.selection]) {
                case 'default':
                    player.runCommandAsync(`title @s actionbar Günaydın`)
                    break;
                case 'Sabah':
                    world.setTimeOfDay(1000);
                    player.runCommandAsync(`title @s actionbar Günaydın`)
                    break;
                case 'Öylen':
                    world.setTimeOfDay(6000);
                    player.runCommandAsync(`title @s actionbar İyi Günler`)
                    break;
                case 'Akşam':
                    world.setTimeOfDay(12000);
                    player.runCommandAsync(`title @s actionbar İyi Akşamlar`)
                    break;
                case 'Gece':
                    world.setTimeOfDay(18000);
                    player.runCommandAsync(`title @s actionbar Hayırlı Geceler`)
                    break;
            }
        }, 20)
    })
}